<?php
namespace Neuron\Person\Attribute;

use Neuron\Db\Adapter\Driver\Pdo\Result;
use Neuron\Upload;
use Neuron\Document\Entity;

class Document extends Entity{

    public function saveAttributeFile($file,$attributeOwner,$attr_code,$sessOwner){
        $result     = new Result;
        // Simpan attribute files to document
        $uploadConfig 	= $this->_storage->getConfig()['upload_document'];
        $uploadPath = $uploadConfig['location'];
        if($uploadConfig['split_folder']){
            $uploadPath = $uploadPath . '/' . date($uploadConfig['split_folder']);
        }

        $upload 		= new Upload\Upload(
            'uploader', $this->_storage->getConfig()['upload_document']
        );

        $upload->handle(array('file' => $file));
        $file_name 	        = $upload->name;
        $file_size 	        = $upload->size;
        $file_type 	        = pathinfo($upload->name, PATHINFO_EXTENSION);
        $file_dir 	        = $uploadPath;

        $documentType 		= new \Neuron\Document\Type(
            \Neuron\Document\Type\Storage::factory(
                $this->_storage->getAdapter(),
                $this->_storage->getConfig()
            )
        );
        $dataDocumentType 		= $documentType->loadByName($attr_code);
        $documentTypeId 		= $dataDocumentType['document_type_id'];

        $document 			= new \Neuron\Document\Entity(
            \Neuron\Document\Entity\Storage::factory(
                $this->_storage->getAdapter(),
                $this->_storage->getConfig()
            )
        );
        
        $dataDocument 		= array(
            "document_no"		=>	"EMP/ATTR/".$attr_code."/".$attributeOwner.'/'.date('Ymd'),
            "document_name"		=>	"Employee Attribute File (".$attr_code.")",
            "document_desc"		=>	"Employee Attribute File (".$attr_code.")",
            "document_dtm"		=>	date('Y-m-d H:i:s'),
            "document_type_id"	=>	$documentTypeId,
            "document_by"		=>	$sessOwner,
            "document_end_dtm"	=> 	null,
        );

        $document->push($dataDocument);
        if($documentId  = $document->save(false)){
            $documentFiles 	= new \Neuron\Document\Files(
                \Neuron\Document\Files\Storage::factory(
                    $this->_storage->getAdapter(),
                    $this->_storage->getConfig()
                )
            );
            $dataFiles 		= array(
                "document_id" => $document->document_id,
                "file_name" => $file_name,
                "file_dir" => $file_dir,
                "file_type" => $file_type,
                "file_size" => $file_size,
                "document_file_status" => 1,
            );

            $documentFiles->push($dataFiles);
            $saveFile = $documentFiles->save(false);
            if($saveFile){
                $documentOwner 	= new \Neuron\Document\Owner(
                    \Neuron\Document\Owner\Storage::factory(
                        $this->_storage->getAdapter(),
                        $this->_storage->getConfig()
                    )
                );
                $ownerData 		= array(
                    "document_id"	 	=> $document->document_id,
                    "owner_ref_code" 	=> "EMPLOYEE",
                    "owner_ref_id" 		=> $attributeOwner,
                    "domain_name" 		=> null,
                    "domain_id" 		=> null,
                );
                $documentOwner->push($ownerData);
                if($documentOwner->save(false)){	
                    $audit 	= new \Neuron\Document\Audit(
                        \Neuron\Document\Audit\Storage::factory(
                            $this->_storage->getAdapter(),
                            $this->_storage->getConfig()
                        )
                    );
                    $dataAudit 	= array(
                        "document_id" => $document->document_id,
                        "user_id" => $sessOwner,
                        "audit_type_id" => 1,
                        "audit_dtm" => date('Y-m-d'),
                        "notes" => null
                    );
                }
            }
        }

        $result->data 	= $documentId;
        return $result;
    }
}