<?php
namespace Neuron\Person\Controller\Api;

class Map extends \Neuron\Person\Controller {

    public function LoadByUserIdAction() {

        $result = new \Neuron\Generic\Result();

        try {

            $storage = \Neuron\Person\Entity\Storage::factory($this->getDb(), $this->getConfig());
            $cpersons = new \Neuron\Person\Entity($storage);
            
            $data = $this->getREST()->getParameters();

            if(!array_key_exists('user_id', $data)){
                $result->code = 20;
                $result->info = 'invalid_request_parameter';
                return $this->getREST()->getResponse($result);
            }
            if (!isset($data['user_id']) || $data['user_id']=='') {
                $result->code = 10;
                $result->info = 'User ID is required';
                return $this->getREST()->getResponse($result);
            }

            $userID = $data['user_id'];
            $dataPerson = $cpersons->loadMap($userID,'user_id');

            $result->guid = $dataPerson['guid'];
            $result->code = $dataPerson['code'];
            $result->info = $dataPerson['info'];
            $result->data = $dataPerson['data'];
			
        } catch (Exception $e) {

            $result->code = 100;
            $result->info = 'error';
            $result->data = array(
                    'message' => $ex->getMessage(),
                );

        }
        
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $data
		); 

		$responseResult = array(
			'guid' => $result->guid,
			'code' => $result->code,
			'info' => $result->info,
			'data' => $result->data
		); 

		$logparam['subject'] = 'API PERSON LOAD BY USER ID';
		$logparam['identity'] = $userID ? $userID : '';
		$logparam['data1'] = $result->data;
		$logparam['description'] = 'Log proses api person load by user id';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode($responseResult);
		
		
		$this->writeLogAction($logparam);
		
		return $this->getREST()->getResponse($result);
    }

}