<?php
return array(
	/*Table structure for table `person_status` */
	"CREATE TABLE `person_status` (
		`status_id` smallint(6) NOT NULL AUTO_INCREMENT,
		`code` varchar(32) NOT NULL,
		`description` varchar(128) DEFAULT NULL,
		PRIMARY KEY (`status_id`)
	) ENGINE=InnoDB;",
	"TRUNCATE TABLE `person_status`;",
	"INSERT INTO `person_status` (`status_id`, `code`, `description`) VALUES (1, 'TK', 'Tidak Kawin');",
	"INSERT INTO `person_status` (`status_id`, `code`, `description`) VALUES (2, 'K0', 'Kawin');",

	/*Table structure for table `person_type` */
	"CREATE TABLE `person_type` (
		`type_id` smallint(6) NOT NULL AUTO_INCREMENT,
		`code` varchar(32) DEFAULT NULL,
		`name` varchar(45) NOT NULL,
		`description` varchar(128) DEFAULT NULL,
		PRIMARY KEY (`type_id`)
	) ENGINE=InnoDB;",
	/*Data for the table `person_type` */
	"TRUNCATE TABLE `person_type`;",
	"INSERT  INTO `person_type`(`type_id`,`code`,`name`,`description`) VALUES (1,'N','Normal',NULL),(2,'D','Disable',NULL);",

	/*Table structure for table `person` */
	"CREATE TABLE `person_parameters` (
		`param_id` int(11) NOT NULL AUTO_INCREMENT,
		`param_ref_name` varchar(32) NOT NULL,
		`param_ref_id` varchar(20) DEFAULT NULL,
		`value1` varchar(255) DEFAULT NULL,
		`value2` varchar(128) DEFAULT NULL,
		`description` varchar(128) DEFAULT NULL,
		`start_date` date NOT NULL,
		`end_date` date DEFAULT NULL,
		PRIMARY KEY (`param_id`)
	) ENGINE=InnoDB;",

	"CREATE TABLE `person` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`code` varchar(32) NOT NULL,
		`first_name` varchar(32) NOT NULL,
		`last_name` varchar(64) DEFAULT NULL,
		`gender` char(1) NOT NULL,
		`birth_date` date DEFAULT NULL,
		`birth_place` varchar(45) DEFAULT NULL,
		`type_id` smallint(6) DEFAULT NULL,
		`status_id` smallint(6) DEFAULT NULL,
		`created_dtm` datetime NOT NULL,
		`created_by` int(11) DEFAULT NULL,
		PRIMARY KEY (`id`),

		KEY `FK_PERSON_STATUS_IDX` (`status_id`),
		KEY `FK_PERSON_TYPE_IDX` (`type_id`),
		CONSTRAINT `FK_PERSON_STATUS` FOREIGN KEY (`status_id`) REFERENCES `person_status` (`status_id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
		CONSTRAINT `FK_PERSON_TYPE` FOREIGN KEY (`type_id`) REFERENCES `person_type` (`type_id`) ON DELETE NO ACTION ON UPDATE NO ACTION

	) ENGINE=InnoDB;",

	/*Table structure for table `person_detail` */
	"CREATE TABLE `person_detail` (
		`detail_id` int(11) NOT NULL AUTO_INCREMENT,
		`person_id` int(11) NOT NULL,
		`join_date` date NOT NULL,
		`termination_date` date DEFAULT NULL,
		`pic_official` varchar(80) DEFAULT NULL,
		`pic_signature` varchar(80) DEFAULT NULL,
		`about` text,
		`flag_geolocation` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 = WITHOUT ; 1 = WITH',
  		`flag_attd_evidence` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 = WITHOUT ; 1 = WITH',
  		`flag_timetable_overlap` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 = NORMAL ; 1 = CONFLICT',
		`termination_reason` TEXT NULL,
		`termination_reason_category` int(11) NULL,
  		`evidence_id` INT NULL,
  		`flag_bpjs_ks` TINYINT(4) NULL,
  		`flag_bpjs_kt` TINYINT(4) NULL,
		PRIMARY KEY (`detail_id`),
		KEY `FK_PSNDET_PSN_IDX` (`person_id`),
		CONSTRAINT `FK_PSNDET_PSN` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",

	/*Table structure for table `person_education` */
	"CREATE TABLE `person_education` (
		`education_id` int(11) NOT NULL AUTO_INCREMENT,
		`person_id` int(11) NOT NULL,
		`education_type` varchar(10) DEFAULT NULL,
		`education_level` tinyint(2) DEFAULT NULL,
		`institution` varchar(64) DEFAULT NULL,
		`departement` varchar(45) DEFAULT NULL,
		`city` varchar(64) DEFAULT NULL,
		`year_entry` year(4) NOT NULL,
		`year_graduated` year(4) DEFAULT NULL,
		`description` varchar(200) DEFAULT NULL,
		PRIMARY KEY (`education_id`),

		KEY `FK_PSNEDU_PSN` (`person_id`),
		CONSTRAINT `FK_PSNEDU_PSN` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE CASCADE ON UPDATE CASCADE

	) ENGINE=InnoDB;",

	/*Table structure for table `person_experiences` */
	"CREATE TABLE `person_experiences` (
		`experience_id` int(11) NOT NULL AUTO_INCREMENT,
		`person_id` int(11) NOT NULL,
		`company_name` varchar(45) NOT NULL,
		`position` varchar(45) DEFAULT NULL,
		`job_desc` varchar(200) DEFAULT NULL,
		`period_start` char(6) NOT NULL DEFAULT 'YYYYMM',
		`period_end` char(6) DEFAULT 'YYYYMM',
		`location` varchar(64) DEFAULT NULL,
		PRIMARY KEY (`experience_id`),

		KEY `FK_PSNEXP_EMP` (`person_id`),
		CONSTRAINT `FK_PSNEXP_EMP` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE CASCADE ON UPDATE CASCADE

	) ENGINE=InnoDB;",
	
	/*Table structure for table `person_family` */
	"CREATE TABLE `person_family` (
		`family_id` int(11) NOT NULL AUTO_INCREMENT,
		`person_id` int(11) NOT NULL,
		`full_name` varchar(60) NOT NULL,
		`identity_number` varchar(40) DEFAULT NULL,
		`gender` varchar(10) DEFAULT NULL,
		`birth_place` varchar(45) DEFAULT NULL,
		`birth_date` date DEFAULT NULL,
		`education` varchar(60) DEFAULT NULL,
		`occupation` varchar(60) DEFAULT NULL,
		`marital_status` varchar(20) DEFAULT NULL,
		`family_position` tinyint(4) DEFAULT NULL COMMENT '1 = husband, 2 = wife, 3 = son, 4 = daughter',
		`start_date` date DEFAULT NULL,
		`end_date` date DEFAULT NULL,
		PRIMARY KEY (`family_id`),

		KEY `FK_PSNFAM_PSN` (`person_id`),
		CONSTRAINT `FK_PSNFAM_PSN` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
	) ENGINE=InnoDB;",

	/*Table structure for table `person_medical_history` */
	"CREATE TABLE `person_medical_history` (
		`medical_id` int(11) NOT NULL AUTO_INCREMENT,
		`person_id` int(11) NOT NULL,
		`medical_type_id` tinyint(3) NOT NULL,
		`medical_description` varchar(80) NOT NULL,
		`treatment_dat` varchar(6) DEFAULT NULL,
		`heredity_source` varchar(32) DEFAULT NULL,
		PRIMARY KEY (`medical_id`),

		KEY `FK_MEDHIST_PERSON_IDX` (`person_id`),
		CONSTRAINT `FK_MEDHIST_PERSON` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
	) ENGINE=InnoDB;",

	/*Table structure for table `person_parameters` */
	"CREATE TABLE `person_parameters` (
		`param_id` int(11) NOT NULL AUTO_INCREMENT,
		`param_ref_name` varchar(32) NOT NULL,
		`param_ref_id` varchar(20) DEFAULT NULL,
		`value1` varchar(255) DEFAULT NULL,
		`value2` varchar(128) DEFAULT NULL,
		`description` varchar(128) DEFAULT NULL,
		`start_date` date NOT NULL,
		`end_date` date DEFAULT NULL,
		PRIMARY KEY (`param_id`)
	) ENGINE=InnoDB;",

	/*Table structure for table `person_user_map` */
	"CREATE TABLE `person_user_map` (
		`user_map_id` int(11) NOT NULL AUTO_INCREMENT,
		`person_id` int(11) NOT NULL,
		`user_id` bigint(20) NOT NULL,
		`start_date` date NOT NULL,
		`end_date` date DEFAULT NULL,
		PRIMARY KEY (`user_map_id`),

		KEY `FK_PERSMAP_PERSON_IDX` (`person_id`),
		CONSTRAINT `FK_PERSMAP_PERSON` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	) ENGINE=InnoDB;",

	"CREATE TABLE `person_attribute_types` (
		`attr_type_id` smallint(6) NOT NULL AUTO_INCREMENT,
		`attr_code` varchar(12) NOT NULL,
		`attr_name` varchar(64) NOT NULL,
		PRIMARY KEY (`attr_type_id`),
		UNIQUE KEY `attr_code_UNIQUE` (`attr_code`)
	  ) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;",
	  
	"CREATE TABLE `person_attributes` (
		`person_attribute_id` int(11) NOT NULL AUTO_INCREMENT,
		`attr_code` varchar(12) NOT NULL,
		`person_id` int(11) NOT NULL,
		`attr_value` varchar(64) NOT NULL,
		`start_date` date NOT NULL,
		`end_date` varchar(45) DEFAULT NULL,
		`document_id` int(11) NULL,
		`update_dtm` datetime NOT NULL,
		`update_by` int(11) NOT NULL,
		PRIMARY KEY (`person_attribute_id`),
		KEY `fk_personattr_emp_idx` (`person_id`),
		KEY `fk_personattr_attrtype_idx` (`attr_code`),
		CONSTRAINT `fk_personattr_attrtype` FOREIGN KEY (`attr_code`) REFERENCES `person_attribute_types` (`attr_code`) ON UPDATE CASCADE,
		CONSTRAINT `fk_personattr_emp` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
	  ) ENGINE=InnoDB DEFAULT CHARSET=latin1;",

	"CREATE TABLE `person_skill` (
		`person_skill_id` int(11) NOT NULL AUTO_INCREMENT,
		`skill_code` varchar(120) NOT NULL,
		`person_id` int(11) NOT NULL,
		`skill_value` varchar(64) NOT NULL COMMENT '1 = Master, 2 = Expert, 3 = Intermediate, 4 = Based',
		`start_date` date NOT NULL,
		`end_date` varchar(45) DEFAULT NULL,
		`document_id` int(11) DEFAULT NULL,
		`update_dtm` datetime NOT NULL,
		`update_by` int(11) NOT NULL,
		PRIMARY KEY (`person_skill_id`),
		KEY `fk_personskill_emp_idx` (`person_id`),
		KEY `fk_personskill_skilltype_idx` (`skill_code`),
		CONSTRAINT `fk_personskill_emp` FOREIGN KEY (`person_id`) REFERENCES `person` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
		CONSTRAINT `fk_personskill_skilltype` FOREIGN KEY (`skill_code`) REFERENCES `person_skill_types` (`skill_code`) ON UPDATE CASCADE
	  ) ENGINE=InnoDB DEFAULT CHARSET=latin1",

	"CREATE TABLE `person_skill_types` (
		`skill_type_id` smallint(6) NOT NULL AUTO_INCREMENT,
		`skill_code` varchar(120) NOT NULL,
		`skill_name` varchar(120) NOT NULL,
		PRIMARY KEY (`skill_type_id`),
		UNIQUE KEY `skill_code_UNIQUE` (`skill_code`)
	  ) ENGINE=InnoDB DEFAULT CHARSET=latin1",
	/* dst... */

	"insert  into `acc_access_objects`(`access_object_code`,`access_object_type_id`,`access_object_parent`,`name`,`description`,`reference`) values 
	('person_add_education',3,'mnu_person','Add Education','Entity Add Education',''),
	('person_add_employee',3,'mnu_person','Add Person','Entity Add Person',''),
	('person_add_experience',3,'mnu_person','Add Experience','Entity Add Experience',''),
	('person_detail_employee',3,'mnu_person','Detail Person','Entity Detail Person',''),
	('person_edit_education',3,'mnu_person','Edit Education','Entity Edit Education',''),
	('person_edit_employee',3,'mnu_person','Edit Person','Entity Edit Person',''),
	('person_edit_experience',3,'mnu_person','Edit Experience','Entity Edit Experience',''),
	('person_remove_education',3,'mnu_person','Remove Education','Entity remove education',''),
	('person_remove_employee',3,'mnu_person','Remove Person','Entity Remove Person',''),
	('person_remove_experience',3,'mnu_person','Remove Experience','Entity Remove Experience','');",


	#insert defaul admin access
	#table : acc_access_grant
	"insert  into `acc_access_grants`(`access_grant_id`,`access_grant_type_id`,`access_object_code`,`access_permission_id`,`subject`,`valid_from`,`valid_until`) values 
	(NULL, 1, 'person_add_education', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_add_employee', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_add_experience', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_detail_employee', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_edit_education', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_edit_employee', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_edit_experience', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_remove_education', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_remove_employee', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_remove_experience', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_set_category_employee', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_set_salary_employee', 4, 1, NOW(), NULL),
	(NULL, 1, 'person_detail_employee', 4, 2, NOW(), NULL);",

	#table: employee_status
	"insert  into `person_status`(`status_id`,`code`,`description`) values 
	(1,'ACT','Active'),
	(2,'TX','Terminated');",

	#table: person_parameters
	"insert  into `person_parameters`(`param_id`,`param_ref_name`,`param_ref_id`,`value1`,`value2`,`description`,`start_date`,`end_date`) values 
	(1,'MEDICAL_TYPE','1','Light Treatment',NULL,'Those that you are  experiencing and/or receiving treatment','2018-01-01',NULL),
	(2,'MEDICAL_TYPE','2','Surgeries / Hospitalization',NULL,'Type of surgery (such as gall bladder) or condition for which you were hospitalized (such as heart attack, pneumonia)','2018-01-01',NULL),
	(3,'MEDICAL_TYPE','3','Allergy',NULL,NULL,'2018-01-01',NULL),
	(4,'MEDICAL_TYPE','4','Hereditary Desease',NULL,'hereditary desease','2018-01-01',NULL),
	(5,'CATEGORY_TYPE','CAT_A',NULL,NULL,'Category A','2018-01-01',NULL),
	(6,'CATEGORY_TYPE','CAT_B',NULL,NULL,'Category B','2018-01-01',NULL),
	(7,'CATEGORY_TYPE','CAT_C',NULL,NULL,'Category C','2018-01-01',NULL),
	(8,'EDUCATION_TYPE','FORMAL','Formal',NULL,'Formal','2018-01-01',NULL),
	(9,'EDUCATION_TYPE','NON_FORMAL','Non_Formal',NULL,'Non_formal','2018-01-01',NULL),
	(10,'EDUCATION_LEVEL','1','Elementary',NULL,'TK/SD','2018-01-01',NULL),
	(11,'EDUCATION_LEVEL','2','Middle School',NULL,'SMP','2018-01-01',NULL),
	(12,'EDUCATION_LEVEL','3','High School',NULL,'SMA','2018-01-01',NULL),
	(13,'EDUCATION_LEVEL','4','Associate degree',NULL,'D1-D3','2018-01-01',NULL),
	(14,'EDUCATION_LEVEL','5','Bachelor\'s degree',NULL,'S1','2018-01-01',NULL),
	(15,'EDUCATION_LEVEL','6','Master\'s degree',NULL,'S2','2018-01-01',NULL),
	(16,'EDUCATION_LEVEL','7','Doctoral degree',NULL,'S3','2018-01-01',NULL),
	(17,'FAMILY_RELATION','HUSBAND','1',NULL,'Husband','2018-01-01',NULL),
	(18,'FAMILY_RELATION','WIFE','2',NULL,'Wife','2018-01-01',NULL),
	(19,'FAMILY_RELATION','SON','3',NULL,'Son','2018-01-01',NULL),
	(20,'FAMILY_RELATION','DAUGHTER','4',NULL,'Daughter','2018-01-01',NULL);",

	"INSERT INTO `person_parameters` (`param_id`,`param_ref_name`,`param_ref_id`,`value1`,`value2`,`description`,`start_date`,`end_date`) VALUES 
	(NULL, 'SKILL_LEVEL', '1', 'Master', NULL, 'Master', '2021-06-18', NULL),
	(NULL, 'SKILL_LEVEL', '2', 'Expert', NULL, 'Expert', '2021-06-18', NULL),
	(NULL, 'SKILL_LEVEL', '3', 'Intermediate', NULL, 'Intermediate', '2021-06-18', NULL),
	(NULL, 'SKILL_LEVEL', '4', 'Based', NULL, 'Based', '2021-06-18', NULL);",

	"insert into `document_type`(`document_type_id`, `parent_type_id`, `name`, `description`)
	values(NULL, NULL, 'Employee', 'Document Employee'),
	(NULL, (select `document_type_id` from `document_type` as dt where `name` = 'Employee' limit 1), 'Contract', 'Document Employee Contract');",
);